library flutter_simplepage_viewe;

import 'package:flutter/widgets.dart';

var indexvalue = 0;
var currentvalue = 0;

bool chanepage = true;


class SimplePageviewer extends StatelessWidget {

  List<Widget> pages = const <Widget>[];
  final Axis scrollDirection;
  final int currentpage;
  final bool swipeenable;
  final Function(int value) onPageChanged;


  SimplePageviewer({
    this.pages,
    this.scrollDirection = Axis.horizontal,
    this.currentpage,
    this.swipeenable = false,this.onPageChanged
  });

  PageController controller = PageController();

  _changepage() async {
    if(chanepage == true){
      chanepage = false;
      await Future.delayed(Duration(milliseconds: 300),(){
        controller.animateToPage(currentpage, duration: Duration(milliseconds: 200), curve: Curves.ease);
      });

    }
  }

  Future _getThingsOnStartup() async {
    indexvalue = currentpage;
    if(swipeenable == true){
      if(chanepage == true){
        await Future.delayed(Duration(milliseconds: 300),(){
          if(indexvalue != null){controller.animateToPage(indexvalue, duration: Duration(milliseconds: 200), curve: Curves.ease);}});
      }
      else{
        if(indexvalue == currentvalue){}
        else{
          chanepage = true;
          _changepage;
        }
      }
    }
    else {
      await Future.delayed(Duration(milliseconds: 300),(){
        if(currentpage != null){controller.animateToPage(currentpage, duration: Duration(milliseconds: 200), curve: Curves.ease);}});
    }

  }



  @override
  Widget build(BuildContext context) {
    _getThingsOnStartup();


    return PageView.builder(
      itemBuilder: (context,position){
        return StatefulBuilder(builder: (BuildContext context,StateSetter setState){
          return pages.elementAt(position);
        });
      },
      scrollDirection: scrollDirection,
      itemCount: pages.length,
      controller: controller,
      physics: swipeenable == false ? NeverScrollableScrollPhysics () : null,
      onPageChanged: (page){
        chanepage = false;
        currentvalue = page+1;
        onPageChanged(page);
      },
    );

  }


}